"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Api = void 0;
var node_fetch_1 = require("node-fetch");
var Error_1 = require("./Error");
var baseURL = 'https://api.decca.tk';
var Api = /** @class */ (function () {
    function Api(key) {
        this.key = key;
        if (!key) {
            throw new Error_1.DeccaApiError('Missing API key!');
        }
    }
    Api.prototype.drip = function (imageUrl) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/canvas/drip?key=" + this.key + "&imgUrl=" + imageUrl);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/canvas/drip?key=" + this.key + "&imgUrl=" + imageUrl)];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.bonk = function (imageUrl) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/canvas/bonk?key=" + this.key + "&imgUrl=" + imageUrl);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/canvas/bonk?key=" + this.key + "&imgUrl=" + imageUrl)];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.brain = function (imageUrl) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/canvas/brain?key=" + this.key + "&imgUrl=" + imageUrl);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/canvas/brain?key=" + this.key + "&imgUrl=" + imageUrl)];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.makeMeme = function (imageUrl, topTxt, botTxt, type) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/canvas/makememe?key=" + this.key + "&imgUrl=" + imageUrl + "&type=" + type.toString() + "&topTxt=" + encodeURIComponent(topTxt) + "&botTxt=" + encodeURIComponent(botTxt));
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/canvas/makememe?key=" + this.key + "&imgUrl=" + imageUrl + "&type=" + type.toString() + "&topTxt=" + encodeURIComponent(topTxt) + "&botTxt=" + encodeURIComponent(botTxt))];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.bright = function (imageUrl, val) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/canvas/bright?key=" + this.key + "&imgUrl=" + imageUrl + "&val=" + val.toString());
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/canvas/bright?key=" + this.key + "&imgUrl=" + imageUrl + "&val=" + val.toString())];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.contrast = function (imageUrl, val) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/canvas/contrast?key=" + this.key + "&imgUrl=" + imageUrl + "&val=" + val.toString());
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/canvas/contrast?key=" + this.key + "&imgUrl=" + imageUrl + "&val=" + val.toString())];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.invert = function (imageUrl) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/canvas/invert?key=" + this.key + "&imgUrl=" + imageUrl);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/canvas/invert?key=" + this.key + "&imgUrl=" + imageUrl)];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.circle = function (imageUrl) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/canvas/circle?key=" + this.key + "&imgUrl=" + imageUrl);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/canvas/circle?key=" + this.key + "&imgUrl=" + imageUrl)];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.yankee = function (imageUrl) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/canvas/yankee?key=" + this.key + "&imgUrl=" + imageUrl);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/canvas/yankee?key=" + this.key + "&imgUrl=" + imageUrl)];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.sus = function (imageUrl) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/canvas/sus?key=" + this.key + "&imgUrl=" + imageUrl);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/canvas/sus?key=" + this.key + "&imgUrl=" + imageUrl)];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.pixel = function (imageUrl) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/canvas/pixel?key=" + this.key + "&imgUrl=" + imageUrl);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/canvas/pixel?key=" + this.key + "&imgUrl=" + imageUrl)];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.ping = function (imageUrl) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/canvas/ping?key=" + this.key + "&imgUrl=" + imageUrl);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/canvas/ping?key=" + this.key + "&imgUrl=" + imageUrl)];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.gun = function (imageUrl) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/canvas/gun?key=" + this.key + "&imgUrl=" + imageUrl);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/canvas/gun?key=" + this.key + "&imgUrl=" + imageUrl)];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.afvsae = function (f1, f2) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/canvas/afvsae?key=" + this.key + "&f1=" + encodeURIComponent(f1) + "&f2=" + encodeURIComponent(f2));
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/canvas/afvsae?key=" + this.key + "&f1=" + encodeURIComponent(f1) + "&f2=" + encodeURIComponent(f2))];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.reverse = function (text) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d, resp;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/string/reverse?key=" + this.key + "&string=" + text);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/string/reverse?key=" + this.key + "&string=" + text)];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [4 /*yield*/, res.json()];
                    case 4:
                        resp = _e.sent();
                        return [2 /*return*/, resp.response];
                }
            });
        });
    };
    Api.prototype.mock = function (text) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d, resp;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/string/mock?key=" + this.key + "&string=" + text);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/string/mock?key=" + this.key + "&string=" + text)];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [4 /*yield*/, res.json()];
                    case 4:
                        resp = _e.sent();
                        return [2 /*return*/, resp.response];
                }
            });
        });
    };
    Api.prototype.randomID = function () {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fetchForErr(baseURL + "/string/randomid?key=" + this.key);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/string/randomid?key=" + this.key)];
                    case 1:
                        res = _a.sent();
                        return [4 /*yield*/, res.json()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Api.prototype.trivia = function () {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fetchForErr(baseURL + "/extra/trivia?key=" + this.key);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/extra/trivia?key=" + this.key)];
                    case 1:
                        res = _a.sent();
                        return [4 /*yield*/, res.json()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Api.prototype.ftl = function () {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fetchForErr(baseURL + "/extra/ftl?key=" + this.key);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/extra/ftl?key=" + this.key)];
                    case 1:
                        res = _a.sent();
                        return [4 /*yield*/, res.json()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Api.prototype.welcome = function (bgImg, topTxt, botTxt, avatar, username, txtColor) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/discord/welcome?key=" + this.key + "&bgImg=" + bgImg + "&topTxt=" + encodeURIComponent(topTxt) + "&botTxt=" + encodeURIComponent(botTxt) + "&avatar=" + avatar + "&username=" + encodeURIComponent(username) + "&txtColor=" + txtColor);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/discord/welcome?key=" + this.key + "&bgImg=" + bgImg + "&topTxt=" + encodeURIComponent(topTxt) + "&botTxt=" + encodeURIComponent(botTxt) + "&avatar=" + avatar + "&username=" + encodeURIComponent(username) + "&txtColor=" + txtColor)];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    Api.prototype.xpCard = function (bgImg, avatar, rank, level, username, discriminator, xp, xpNeeded) {
        return __awaiter(this, void 0, void 0, function () {
            var res, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        fetchForErr(baseURL + "/discord/xp?key=" + this.key + "&bgImg=" + bgImg + "&rank=" + rank.toString() + "&level=" + level.toString() + "&username=" + encodeURIComponent(username) + "&discriminator=" + encodeURIComponent(discriminator) + "&xp=" + xp.toString() + "&xpNeeded=" + xpNeeded.toString() + "&avatar=" + avatar);
                        return [4 /*yield*/, node_fetch_1.default(baseURL + "/discord/xp?key=" + this.key + "&bgImg=" + bgImg + "&rank=" + rank.toString() + "&level=" + level.toString() + "&username=" + encodeURIComponent(username) + "&discriminator=" + encodeURIComponent(discriminator) + "&xp=" + xp.toString() + "&xpNeeded=" + xpNeeded.toString() + "&avatar=" + avatar)];
                    case 1:
                        res = _e.sent();
                        if (!!res.ok) return [3 /*break*/, 3];
                        _a = Error_1.DeccaApiError.bind;
                        _b = "An error occured during fetch!\nError: ";
                        _d = (_c = JSON).stringify;
                        return [4 /*yield*/, res.json()];
                    case 2: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                    case 3: return [2 /*return*/, res.url];
                }
            });
        });
    };
    return Api;
}());
exports.Api = Api;
var fetchForErr = function (url) {
    node_fetch_1.default(url).then(function (res) { return __awaiter(void 0, void 0, void 0, function () {
        var _a, _b, _c, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (!!res.ok) return [3 /*break*/, 2];
                    _a = Error_1.DeccaApiError.bind;
                    _b = "An error occured regarding authentication.\nStatus: " + res.status + "\nError: ";
                    _d = (_c = JSON).stringify;
                    return [4 /*yield*/, res.json()];
                case 1: throw new (_a.apply(Error_1.DeccaApiError, [void 0, _b + _d.apply(_c, [_e.sent()])]))();
                case 2: return [2 /*return*/];
            }
        });
    }); });
};
